#include "ymcallback.h"
#include <stdio.h>

extern FILE *logfd;

/* non used callbacks Some have loggin performed */
int	ext_yahoo_log (const char *fmt, ...)
{
  	return 0;
}

void	ext_yahoo_got_identities (int id, YList * ids)
{
        fprintf(logfd,"NOP: got identities\n");
}
void	ext_yahoo_chat_yahoologout (int id, const char *me)
{	
	fprintf(logfd,"NOP: got chat logout\n");
}
void	ext_yahoo_chat_yahooerror (int id, const char *me)
{
        fprintf(logfd,"ERR: yahoo error id = %d\n", id);
}
void	ext_yahoo_got_search_result (int id, int found, int start,
	                            int total, YList * contacts)
{
        fprintf(logfd,"NOP: got search results\n");
}


void	ext_yahoo_got_file (int id, const char *me, const char *who, const char *url, long expires,
	                    const char *msg, const char *fname, unsigned long fesize)
{
        fprintf(logfd,"NOP: got file from %s\n", who);
}

void	ext_yahoo_conf_message (int id, const char *me, const char *who, const char *room, const char *msg, int utf8)
{
	fprintf(logfd,"NOP: got conf msg from %s\n", who);
}

void	ext_yahoo_got_conf_invite (int id, const char *me, const char *who, const char *room, const char *msg,
			   YList * members)
{
	fprintf(logfd,"NOP: got conf invite from %s\n", who);
}

void	ext_yahoo_conf_userdecline (int id, const char *me, const char *who, const char *room, const char *msg)
{
	fprintf(logfd,"NOP: got decline from %s\n", who);
}

void	ext_yahoo_conf_userjoin (int id, const char *me, const char *who, const char *room)
{	
	fprintf(logfd,"NOP: %s joined the conf\n", who);
}

void	ext_yahoo_conf_userleave (int id, const char *me, const char *who, const char *room)
{
	fprintf(logfd,"NOP: %s left the conf\n", who);
}

void	ext_yahoo_chat_cat_xml (int id, const char *xml)
{
	fprintf(logfd,"NOP: xml something blah\n");
}

void	ext_yahoo_chat_join (int id, const char *me, const char *room, const char *topic, YList * members, int fd)
{
	fprintf(logfd,"NOP: joined chat room\n");
}
void	ext_yahoo_chat_userjoin (int id, const char *me, const char *room, struct yahoo_chat_member *who)
{	
	fprintf(logfd,"NOP: user joined chat room\n");
}

void	ext_yahoo_chat_userleave (int id, const char *me, const char *room, const char *who)
{
	fprintf(logfd,"NOP: user left chat room\n");
}

void	ext_yahoo_got_ignore (int id, YList * igns)
{
	fprintf(logfd,"NOP: got ignore \n");
}

void	ext_yahoo_rejected (int id, const char *who, const char *msg)
{
	fprintf(logfd,"NOP: %s rejected you\n", who);
}

void	ext_yahoo_contact_added (int id, const char *myid, const char *who, const char *msg)
{
	fprintf(logfd,"NOP: %s has added you\n", who);
}

void	ext_yahoo_game_notify (int id, const char *me, const char *who, int stat)
{	
	fprintf(logfd,"NOP: game notification from %s\n", who);
}

extern void ymshell_notify_mailreceipt(char *, char *);

void	ext_yahoo_mail_notify (int id, const char *from, const char *subj, int cnt)
{
	ymshell_notify_mailreceipt(from, subj);
	fprintf(logfd,"INF: you have mail from %s\n", from);
}

void	ext_yahoo_got_webcam_image (int id, const char *who,
			    const unsigned char *image,
			    unsigned int image_size, unsigned int real_size,
			    unsigned int timestamp)
{
	fprintf(logfd,"NOP: webcam stuff\n");
}

void	ext_yahoo_webcam_viewer (int id, const char *who, int connect)
{
	fprintf(logfd,"NOP: webcam stuff\n");
}

void	ext_yahoo_webcam_closed (int id, const char *who, int reason)
{	
	fprintf(logfd,"NOP: webcam stuff\n");
}

void	ext_yahoo_webcam_data_request (int id, int send)
{
	fprintf(logfd,"NOP: webcam stuff\n");
}

void	ext_yahoo_webcam_invite (int id, const char *me, const char *from)
{
	fprintf(logfd,"NOP: webcam stuff\n");
}

void	ext_yahoo_webcam_invite_reply (int id, const char *me, const char *from, int accept)
{
	fprintf(logfd,"NOP: webcam stuff\n");
}

void	ext_yahoo_system_message (int id, const char *msg)
{
 	fprintf(stderr,"INF: system msg is %s", msg);
}

void 	ext_yahoo_typing_notify (int id, const char *me, const char *who, int stat)
{
		
}

void 	ext_yahoo_got_cookies(int id)
{

}

void	ext_yahoo_got_buddyicon(int id, const char *me, const char *who, const char *url, int checksum)
{

}


void ext_yahoo_got_buddyicon_checksum(int id, const char *me,const char *who, int checksum) {}

void ext_yahoo_got_buddyicon_request(int id, const char *me, const char *who) {} 

void ext_yahoo_buddyicon_uploaded(int id, const char *url) {}

void ext_yahoo_got_ping(int id, const char *errormsg) {}
