#include "ymcontext.h"
#include "ymshell.h"

int num_context=10;
char **send_cl;
char **recv_cl;
char **context;
extern void drop_prompt();
extern void ymshell_restore_history(char *to_id);
extern ymshell_vals cfg;

int ymsearch_cl(char **haystack, char *needle) {
	int i;
	for(i=0; i<num_context; ++i) 
		if(!strcmp(needle, haystack[i])) 
			return i;
	return num_context-1;
}

void ymupdate_cl(char **list, char* id) {
	int i, j;
	i = ymsearch_cl(list, id);
	for(j=i; j>0; --j)
		strcpy(list[j], list[j-1]);
	strcpy(list[0], id);
	return;
}

void ymupdate_context() {
	int i, j=0;
	for(i=0; i<num_context; ++i) {
		if(strlen(context[i])) {
			if(!strcmp(to_id, context[i])) 
				return;
		}
		else {
			j=1;
			strcpy(context[i], to_id);
			break;
		}
	}
	if(!j) {
		for(i=num_context-1; i>=0; --i)
			if(strlen(send_cl[i]))
				break;
		if((i = ymsearch_cl(context, send_cl[i]))==num_context)
			return;
		strcpy(context[i], to_id);
	}
	return;
}

void ymswitch_context(int i) {
	i = i-'0';
	if(!strlen(context[i])) {
		beep();
		printw("\n");
		drop_prompt();
		return;
	}
	strcpy(to_id, context[i]);
	cfg.message_mode=1;
	ymshell_restore_history(to_id);
	drop_prompt();
}

void ymcycle_context(char **list) {
	static int i;
	int j, k;
	if(cfg.reset_flag) {
		i=0;
		cfg.reset_flag=0;
	}
	for(j=0; j<num_context; ++j) {
		k=(i+j)%num_context;
		if(strlen(list[k])) {
			strcpy(to_id, list[k]);
			i=(k+1)%num_context;
			cfg.message_mode=1;
			break;
		}			
	}
	ymshell_restore_history(to_id);
	drop_prompt();
}

void ymremove_context(char *who, char **list)
{
	int j = 0;
	if(list != NULL)
	{
		for( ; j < num_context; j++)
		{
			if(strcmp(list[j], who) == 0)
			{
				list[j][0] = '\0';
				return;
			}	
		}	
	}
	else
	{
		ymremove_context(who, context);
		ymremove_context(who, recv_cl);
		ymremove_context(who, send_cl);
	}	
}	
