#ifndef _YMSECURE_H
#define _YMSECURE_H

struct ymsec_keyinfo
{
	struct ymsec_keyinfo *link;
	char yid[256];
	unsigned char *key;
	unsigned int flag;
	unsigned int recvnum;
	unsigned int rnd;
	unsigned int sesskey;
};	

#define HASHSZ 		16
#define SECURE 		0
#define NOSECURE 	1
#define TRY_SECURE 	2

#define YMSECURE_NOYMSHELL 	0x01
#define YMSECURE_SIGSENT   	0x02
#define YMSECURE_SECRETSENT 	0x04
#define YMSECURE_KEYEXISTS	0x08

#define HNDSHK_REPLY_1 	   "YMR1"
#define HNDSHK_REPLY_2	   "YMR2"

#define YMSHELL_SIGN "    \t\t\t    \t\t  \t \t\t \t    \t \t\t \t \t\t   \t\t    \t\t    \t\t \t\t \t\t \t\t"

#define DONTDISPLAY	999

#define RAND_MX		25
#define PRIME		7
#define PRIMV		3
#define MAX_BUF		255
#define MD5_DIGEST_SZ	16

extern struct ymsec_keyinfo gbl_keys[];
extern void send_msg_unconditional(char *, char *);

int yahoo_secure_im(char *, char *);
struct ymsec_keyinfo *ymsecure_findkey(char *);
struct ymsec_keyinfo *ymsecure_allocinfo(char *);
int ymsecure_hashid(char *);
void ymsecure_start_handshake(char *);
void ymsecure_encandsend(char *, char *, struct ymsec_keyinfo *);
int ymsecure_statemanage(char *, char *);
void ymsecure_checkreplyforsign(struct ymsec_keyinfo *, char *);
void ymsecure_checkreplyforsecret(struct ymsec_keyinfo *, char *);
int ymsecure_checksign(char *, char *);
void ymsecure_sendsignreply(struct ymsec_keyinfo *, char *);
void ymsecure_sendfinalreply(struct ymsec_keyinfo *, char *);
void ymsecure_calckey(struct ymsec_keyinfo *);
void ymsecure_mdkeymake(struct ymsec_keyinfo *);
void ymsecure_decrypt(struct ymsec_keyinfo *, char *);
int ymsecure_b64encode(unsigned char *, int );
void ymsecure_doblock(unsigned char [], unsigned char [], int, int);
void ymsecure_update_state(char *);
void ymsecure_find_delkey(char *);

#endif
