#ifndef YMSHELL_H
#define YMSHELL_H
/*
 * sample yahoo client based on libyahoo2
 *
 * libyahoo2 is available at http://libyahoo2.sourceforge.net/
 *
 * $Revision: 1.72 $
 * $Date: 2004/01/16 05:38:46 $
 * 
 * Copyright (C) 2002-2004, Philip S Tellis <philip.tellis AT gmx.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include <netdb.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>

#include <termios.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>

/* Get these from http://libyahoo2.sourceforge.net/ */
#include <curses.h>
#include <libyahoo2/yahoo2.h>
#include <libyahoo2/yahoo2_callbacks.h>
#include "yahoo_util.h"
#include "ymcallback.h"
#include "ymgroup.h"
#include "ymcontext.h"
/* all DS's */

#define INCTX		1
#define OFFLINE		2
#define INCTX_DIFFUSER	3
#define NOCTX		4

#define CTRL_MAP(x) 	(x&(0x1f))

#define MAX_PREF_LEN 	255	
#define MAX_BUF		255
#define MSG_BUF		1024
#define LARGE_BUF	4096

#define NOTIFY_GAP 	120

#define SPAM 		1
#define NOSPAM 		0

#define SENT		1
#define RECD		0


typedef struct
{
	char yahoo_id[MAX_BUF];
	char password[MAX_BUF];
	int id;
	int fd;
	int status;
	char *msg;
} yahoo_local_account;

typedef struct yahoo_account
{
  	char yahoo_id[MAX_BUF];
	char name[MAX_BUF];
	int status;
	int away;
	char *msg;
	char group[MAX_BUF];
} yahoo_account;

typedef struct
{
	int id;
	char *label;
} yahoo_idlabel;

typedef struct
{
  	int id;
 	char *who;
} yahoo_authorize_data;

typedef struct shortcuts
{
	char send_cycle;
	char recv_cycle;
} shortcuts_t;

typedef struct ymshell_flags
{
#define BYTE unsigned char
#define WORD unsigned short
	BYTE message_mode;
	BYTE notice;
	BYTE poll_loop;
	BYTE connected;
	BYTE ar;
	BYTE kde_pres;
	BYTE secure;
	BYTE reset_flag;
	WORD port_to_use;
	WORD max_hist;
	WORD init_state;
#undef BYTE
#undef WORD
} ymshell_vals;	

typedef struct ymshell_msgbuf
{	
	char *buf;		/* buffer */
	unsigned char type;	/* sent or recevied */
	struct ymshell_msgbuf *nxt;
} ymshell_msgs;

typedef struct ymshell_msghist
{
	char id[MAX_BUF];
	ymshell_msgs *msgs;	/* list of buffers */
	unsigned char num;
	struct ymshell_msghist *nxt;
} ymshell_msglist;	

extern yahoo_idlabel yahoo_status_codes[];

extern char *help_string;
extern char *local_host;
extern int poll_loop;
extern yahoo_local_account *ylad;
extern YList *buddies;
struct YGroupList;
extern struct YGroupList *buddygroups;
extern FILE *logfd;
extern char to_id[MAX_BUF];
extern char from_id[MAX_BUF];
extern int message_mode;
extern int init_state;
extern char st[MAX_BUF];

void init_rest();

#endif	
